use `telerec`;

create table `rec_recordings_tmp` (
  `recording_id` int(10) unsigned not null auto_increment,
  `uniqueid` varchar(255) not null,
  `extension_id` int(10) unsigned not null,
  `number` varchar(255) not null,
  `calltype` int(11) not null,
  `rating` int(10) default null,
  `reference` varchar(255) default null,
  `recfile` varchar(255) not null,
  `calldate` datetime not null,
  `duration` int(11) not null,
  primary key (`recording_id`),
  foreign key (`extension_id`) references `rec_extensions` (`extension_id`) on delete cascade
) character set utf8 collate utf8_unicode_ci;

insert into rec_recordings_tmp (
  `uniqueid`,
  `extension_id`,
  `number`,
  `calltype`,
  `rating`,
  `reference`,
  `recfile`,
  `calldate`,
  `duration`)
  select
    r.`call_id`,
    e.`extension_id`,
    case
       when (c.`calltype` = 1) then if((e.extension = c.destination), c.destination, c.source)
       when (c.`calltype` = 2) then if((length(c.`source`)), c.`source`, 'NCID')
       when (c.`calltype` = 3) then c.destination
     end as nummber,
    if((c.`calltype` = 1), if((e.extension = c.destination), 4, 5), c.`calltype`) as calltype,
    r.rating,
    r.reference,
    if(length(r.recfile_path) > 0, r.`recfile_path`, c.`recfile`),
    c.`calldate`,
    c.`billsec`
  from `rec_recordings` r
    inner join `rec_extensions` e
      on r.`extension_id` = e.`extension_id`
    inner join `asterisk`.`cdr` c
      on c.`uniqueid` = r.`call_id`
    group by r.`call_id`, e.`extension_id`;

drop table rec_recordings;
rename table `rec_recordings_tmp` to `rec_recordings`;

create table `rec_recording_flags_tmp` (
  `recording_id` int(10) unsigned not null,
  `flag_id` int(10) not null,
  foreign key (`recording_id`) references `rec_recordings` (`recording_id`) on delete cascade,
  foreign key (`flag_id`) references `rec_flag_items` (`flag_id`) on delete cascade
) character set utf8 collate utf8_unicode_ci;

insert into `rec_recording_flags_tmp` (
  `recording_id`,
  `flag_id`)
  select
    r.`recording_id`,
    rf.`flag_id`
  from `rec_recording_flags` rf
    inner join `rec_recordings` r
      on rf.`call_id` = r.`uniqueid`
      and rf.extension_id = r.extension_id;

drop table rec_recording_flags;
rename table `rec_recording_flags_tmp` to `rec_recording_flags`;

create table `rec_recording_notes_tmp` (
  `recording_id` int(10) unsigned not null,
  `note` varchar(255) not null,
  `datetime` datetime not null,
  `user_id` int(10) unsigned not null,
  foreign key (`recording_id`) references `rec_recordings` (`recording_id`) on delete cascade,
  foreign key (`user_id`) references `rec_users` (`id`) on delete cascade
) character set utf8 collate utf8_unicode_ci;

insert into `rec_recording_notes_tmp` (
  `recording_id`,
  `note`,
  `datetime`,
  `user_id`)
  select
    r.`recording_id`,
    rn.`note`,
    rn.`datetime`,
    rn.`user_id`
  from `rec_recording_notes` rn
    inner join `rec_recordings` r
      on rn.`call_id` = r.`uniqueid`
      and rn.extension_id = r.extension_id
  group by r.`uniqueid`, r.`extension_id`;

drop table rec_recording_notes;
rename table `rec_recording_notes_tmp` to `rec_recording_notes`;

alter table `rec_extensions` drop column `serial`;