use `telerec`;

SET @table_name = 'rec_users';
SET @column_name = 'tenant_id';
SET @referenced_table_name = 'rec_tenants';
SET @referenced_column_name = 'id';
SET @db_name = 'telerec';

SET @constraint_name = (
    SELECT constraint_name
    FROM INFORMATION_SCHEMA.KEY_COLUMN_USAGE
    WHERE TABLE_NAME = @table_name
      AND COLUMN_NAME = @column_name
      AND CONSTRAINT_SCHEMA = @db_name
      AND referenced_table_name = @referenced_table_name
      AND referenced_column_name = @referenced_column_name);

SET @s = concat('alter table ', @table_name, ' drop foreign key ', @constraint_name);
PREPARE stmt FROM @s;
EXECUTE stmt;
DEALLOCATE PREPARE stmt;

drop table `rec_tenants`;

alter table rec_extensions
    add column `tenant_id` int unsigned null default null;

update rec_extensions set `tenant_id` = 1 where `tenant_id` is null;

alter table `rec_flags_profiles`
    add column `default` enum('yes','no') not null default 'no',
    add column `tenant_id` int unsigned null default null;

update rec_flags_profiles set `tenant_id` = 1 where `tenant_id` is null;
update rec_flags_profiles set `default` = 'yes' where `flag_profile_id` = 1;

alter table `rec_teams`
    add column `default` enum('yes','no') not null default 'no',
    add column `tenant_id` int unsigned null default null;

update rec_teams set `tenant_id` = 1 where `tenant_id` is null;
update rec_teams set `default` = 'yes' where `team_id`  = 1;

alter table `rec_users`
 add column `super_admin` enum('yes','no') not null default 'no',
 add column `default` enum('yes','no') not null default 'no';

update `rec_users` set `super_admin` = 'yes', `default` = 'yes' where `profile_id` = 1;

update `rec_users_profiles` set `profile` = 'Administrator' where `id` = 1;

alter table `rec_users_profiles`
 drop column `superadmin`;

alter table `rec_filters`
    add column `tenant_id` int unsigned null default null;

update `rec_filters` set `tenant_id` = 1 where `tenant_id` is null;

alter table `rec_backups`
    add column `tenant_id` int unsigned null default null;

update `rec_backups` set `tenant_id` = 1 where `tenant_id` is null;

alter table rec_user_supervisors
 drop foreign key `rec_user_supervisors_ibfk_1`,
 drop foreign key `rec_user_supervisors_ibfk_2`;

alter table rec_user_teams
 drop foreign key `rec_user_teams_ibfk_1`,
 drop foreign key `rec_user_teams_ibfk_2`;

alter table rec_user_supervisors
 add foreign key (`user_id`) references `rec_users` (`id`) on delete cascade;

alter table rec_user_teams
    add foreign key (`user_id`) references `rec_users` (`id`) on delete cascade;


alter table `rec_users_profiles`
    add column `tenant_id` int unsigned null default null;

update `rec_users_profiles` set `tenant_id` = 1 where `tenant_id` is null;

alter table `rec_schedules_profiles`
    add column `tenant_id` int unsigned null default null;

update `rec_schedules_profiles` set `tenant_id` = 1 where `tenant_id` is null;

alter table `rec_maintenance`
    add column `id` int unsigned not null auto_increment first,
    add column `tenant_id` int unsigned null default null,
    add primary key (`id`);

update `rec_maintenance` set `tenant_id` = 1 where `tenant_id` is null;

