use `telerec`;

alter table `rec_users_profiles`
 drop column if exists owner,
 drop column if exists create_users;

create table if not exists `rec_profile_types` (
  `id` int unsigned not null auto_increment,
  `type` varchar(255) not null,
  primary key(`id`),
  unique(`type`)
) character set utf8 collate utf8_unicode_ci;

insert into `rec_profile_types` (`id`, `type`) values
 (1,'administrator'),
 (2,'manager'),
 (3,'supervisor'),
 (4,'agent');

alter table `rec_users_profiles`
 modify column `type` int unsigned not null;

alter table `rec_users_profiles`
 add foreign key (`type`) references `rec_profile_types` (`id`) on delete cascade;

alter table `rec_users`
 add foreign key (`type`) references `rec_profile_types` (`id`) on delete cascade;

create table `rec_modules_permissions` (
 `profile_id` int unsigned not null,
 `module_id` int unsigned not null,
 foreign key (`profile_id`) references `rec_users_profiles` (`id`) on delete cascade,
 foreign key (`module_id`) references `rec_modules` (`module_id`) on delete cascade
) character set utf8 collate utf8_unicode_ci;

/*Administrator Permissions*/
insert into `rec_modules_permissions`
 select
    1,
    `module_id`
 from `rec_modules` where `module_id` not in (
     select `module_id` from `rec_modules_restrictions` where `profile_id` = 1
 );

/*Manager Permissions*/
insert into `rec_modules_permissions`
select
    2,
    `module_id`
from `rec_modules` where `module_id` not in (
    select `module_id` from `rec_modules_restrictions` where `profile_id` = 2
);

/*Supervisor Permissions*/
insert into `rec_modules_permissions`
select
    3,
    `module_id`
from `rec_modules` where `module_id` not in (
    select `module_id` from `rec_modules_restrictions` where `profile_id` = 3
);

/*Agent Permissions*/
insert into `rec_modules_permissions`
select
    4,
    `module_id`
from `rec_modules` where `module_id` not in (
    select `module_id` from `rec_modules_restrictions` where `profile_id` = 4
);

drop table rec_modules_restrictions;