var filters_form = $("#filters_form");
var extensions = filters_form.find('#extensions');
var flags = filters_form.find('#filters-flags');

$(function () {
	filters_form.validate(Validations);
	var team = filters_form.find('#team_id');

	var filter = filters_form.find('#filter_id');
	filters_form.find('.table-container').repeatable({
		template: "#filters_tpl",
		startWith: 1,
		onAdd: function(){
			filters_form.find('.bootstrap-toggle').bootstrapToggle({
				onstyle: 'success',
				width: 70
			});

			restart_elements();
		}
	});

	toggle_flags(team.val());

	team.on('change', function() {
		pbx_request('filters', 'reload_extension_dropdown', null, $(this).val(), null, false);
		toggle_flags($(this).val());
		if($(this).val() > 0)
			pbx_request('filters', 'reload_flag_dropdown', null, $(this).val(), null, false);
	});

	Ombutel.on('change', '.search_criteria', function () {
		var row = '.row_' + $(this).data('row');
		$(this).data('val', $(this).val());
		$(row + '.mode_criteria').val('exactly');
		$(row + '.value_criteria').val('');
		toggle_values($(this).val(), row);
	});

	restart_elements();

	$('.condition_criteria').each(function() {
		if($(this).data('val') === 'or')
			$(this).bootstrapToggle('on');
	});

	$('.search_criteria, .mode_criteria, .duration_mode_criteria, .calltype_criteria, .rating_criteria').each(function() {
		var value = $(this).data('val');
		if(value.length > 0 || value > 0) {
			$(this).val(value);
		}
	});

	$('.bootstrap-toggle').each(function() {
		$(this).bootstrapToggle({
			onstyle: 'success',
			width: 70
		});
	});
});

function restart_elements() {
	$('.search_criteria').each(function() {
		var row = '.row_' + $(this).data('row');
		toggle_values($(this).data('val'), row);
	});
}

function toggle_flags(team_id) {
	if(team_id !== 'all') {
		flags.show();
	} else {
		flags.hide();
	}
}

function toggle_values(search_by, row) {
	$(row + '.hide_elements').addClass('hidden');

	switch (search_by) {
		case 'rating':
			$(row + '.duration_mode_criteria, ' + row + '.rating_criteria').removeClass('hidden');
			$(row + '.mode_criteria').addClass('hidden');
			break;
		case 'calltype':
			$(row + '.calltype_criteria').removeClass('hidden');
			$(row + '.mode_criteria').removeClass('hidden').attr('disabled', true);
			break;
		case 'duration':
			$(row + '.duration_mode_criteria, ' + row + '.value_criteria').removeClass('hidden');
			$(row + '.mode_criteria').addClass('hidden');
			break;
		default:
			$(row + '.value_criteria, ' + row + '.mode_criteria').removeClass('hidden').removeAttr('disabled');
			break;
	}
}