var panel_form = $("#panel_form");


$(function () {
	var rec_table = panel_form.find('#panel-recording-table').DataTable({
		processing: true,
		serverSide: true,
		displayLength: 50,
		ajax: {
			url : CallBack,
			type: 'POST',
			data: {
				class : 'panel',
				method : 'get_data'
			}
		},
		lengthChange: false,
		responsive: false,
		searching: false,
		autoWidth: false,
		bSort: false,
		columns: [
			{ "data": "date_time", "className": "text-center visible-lg"},
			{ "data": "team", "className": "text-center hidden-xs"},
			{ "data": "cid", "className": "text-center"},
			{ "data": "from", "className": "text-center"},
			{ "data": "to", "className": "text-center"},
			{ "data": "calltype", "className": "text-center visible-md visible-lg"},
			{ "data": "duration", "className": "text-center hidden-xs"},
			{ "data": "actions", "className": "text-center"}
		],
		columnDefs: [
			{
				"targets": [7],
				"createdCell": function(td, cell_data, row_data) {
					var cell_content = '';
					$.each(cell_data, function (index, data) {
						cell_content = create_btn_action(cell_content, data, row_data.recording_id, row_data.cdr_id);
						$(td).html(cell_content);
					});
				}
			}
		],
		"language" : {
			"emptyTable" : no_data_label
		},
		createdRow: function (row, data) {
			$(row).attr('data-recording-id', data.recording_id);
			$(row).attr('data-cdr-id', data.cdr_id);
		},
		initComplete: function (settings, json) {
			panel_form.find('#calls-indicator').text(json.recordsFiltered);
		}
	});

});