var search_calls_form = $("#search_calls_form");
var calldate = search_calls_form.find('#calldate');
var sc_flags = search_calls_form.find('#search-calls-flags');
var sc_team = search_calls_form.find('#team_id');
var none_hide = search_calls_form.find('.none-hide');
var search_btn = search_calls_form.find('.search-button');
var table = search_calls_form.find('#sc-recording-table');
var user_type;

var agent_role = '4';

$(function () {
	var filter = search_calls_form.find('#filter_id');
	var extensions = search_calls_form.find('#extensions');
	user_type = search_calls_form.find('#user_type').val();

	toggle_calldate(calldate.val());
	toggle_filter(filter.val());

	var from = search_calls_form.find('#from');
	var to = search_calls_form.find('#to');

	$.timepicker.datetimeRange(
		from,
		to,
		{
			dateFormat: 'yy-mm-dd',
			timeFormat: 'HH:mm:ss',
			showSecond: false,
			start: {
				maxDate: new Date()
			}
		}
	);

	search_calls_form.find('#n_days').removeClass('hidden');

	filter.on('change', function() {
		var option = $(this).val();
		toggle_filter(option);
		pbx_request('search_calls', 'get_content', 'get', option);
	});

	toggle_sc_flags(sc_team.val());

	sc_team.on('change', function() {
		pbx_request('search_calls', 'reload_extension_dropdown', null, $(this).val(), null, false);
		if($(this).val() !== 'all') {
			pbx_request('search_calls' , 'reload_flag_dropdown' , null , $(this).val() , null , false);
		}
		toggle_sc_flags($(this).val());
	});

	calldate.on('change', function() {
		var option = $(this).val();
		toggle_calldate(option);
	});

	Ombutel.on('change', '.search_criteria', function () {
		var row = '.row_' + $(this).data('row');
		$(row + '.mode_criteria').val('exactly');
		$(row + '.value_criteria').val('');
		toggle_values($(this).val(), row);
	});

	search_btn.on('click', function () {
		$.fn.dataTable.ext.errMode = 'throw';
		if($.fn.DataTable.isDataTable('#sc-recording-table'))
			table.DataTable().destroy();
		table.removeClass('hidden');

		var buttons = [];
		if(user_type !== agent_role) {
			buttons = [
				{
					title: 'Recording Report',
					text: '<i class="fa fa-file-text-o"></i> CSV',
					action: function() {
						var data = rec_table.columns(0).data().join();
						if(data.length) {
							var form_data = search_calls_form.serializeObject();
							form_data['method'] = 'exportCalls';
							form_data['format'] = 'csv';
							var str = jQuery.param( form_data );
							//console.log(window.location);
							window.location = window.location.pathname + '?' + str;
						} else {
							sendNotification('warning', no_data_label, 2000);
						}
					}
				},
				{
					title: 'Recording Report',
					text: '<i class="fa fa-save"></i> ' + save_label,
					action: function() {
						var data = rec_table.columns(0).data().join();
						if(data.length) {
							pbx_request('search_calls' , 'modal_save_recfiles' , '' , data);
						} else {
							sendNotification('warning', no_data_label, 2000);
						}
					}
				}
			];
		}

		var rec_table = table.DataTable({
			processing: true,
			serverSide: true,
			lengthMenu: [10, 25, 50, 100, 250, 500, 1000],
			displayLength: 50,
			ajax: {
				url : CallBack,
				type: 'POST',
				data: function (d) {
					var form_data = search_calls_form.serializeObject();
					form_data['dtables'] = d;
					form_data['method'] = 'DTSearch';

					return form_data;
				}
			},
			responsive: false,
			searching: false,
			autoWidth: false,
			bSort: false,
			columns: [
				{ "data": "date_time", "className": "text-center visible-lg"},
				{ "data": "team", "className": "text-center hidden-xs"},
				{ "data": "cid", "className": "text-center"},
				{ "data": "from", "className": "text-center"},
				{ "data": "to", "className": "text-center"},
				{ "data": "calltype", "className": "text-center visible-md visible-lg"},
				{ "data": "duration", "className": "text-center hidden-xs"},
				{ "data": "rating", "className": "text-center visible-md visible-lg"},
				{ "data": "actions", "className": "text-center"}
			],
			columnDefs: [
				{
					"targets": [7],
					"createdCell": function(td, cell_data, row_data) {
						$(td).html(
							"<div class='rating' data-recording-id='" + row_data.recording_id + "'></div>"
						);

						$(td).find('.rating').raty({
							score       : cell_data,
							hints       : ['Deficient', 'Regular', 'Good', 'Very Good', 'Excelent'],
							starOn      : 'resources/img/star-on.png',
							starOff     : 'resources/img/star-off.png'
						});
					}
				},
				{
					"targets": [ 8 ],
					"createdCell": function(td, cell_data, row_data) {
						var cell_content = '';
						$.each(cell_data, function (index, data) {
							cell_content = create_btn_action(cell_content, data, row_data.recording_id, row_data.cdr_id);
							$(td).html(cell_content);
						});
					}
				}
			],
			"language" : {
				"emptyTable" : no_data_label
			},
			createdRow: function (row, data) {
				$(row).attr('data-recording-id', data.recording_id);
				$(row).attr('data-cdr-id', data.cdr_id);
			}
		});

		new $.fn.dataTable.Buttons( rec_table, {
			buttons: buttons
		});

		rec_table.buttons().container()
			.appendTo($('.col-sm-6:eq(1)', rec_table.table().container()));

		if(user_type === agent_role)
			//Hide Team, From, and Raiting
			rec_table.columns([1, 3, 7]).visible(false);
	});
});

function toggle_sc_flags(team_id) {
	if(team_id !== 'all') {
		sc_flags.show();
	} else {
		sc_flags.hide();
	}
}

function toggle_filter(option) {
	var from = search_calls_form.find('.form-group-from');

	if(option === 'none') {
		none_hide.parent().parent().hide();
		$('.filter-hide').parent().parent().show();
		from.show();
	} else {
		none_hide.parent().parent().show();
		$('.filter-hide').parent().parent().hide();
		toggle_calldate(calldate.val());
	}
}

function toggle_calldate(option) {
	var custom = search_calls_form.find('.form-group-from');
	var n_days = search_calls_form.find('.form-group-n_days');

	if(option === 'custom') {
		custom.show();
	} else {
		custom.hide();
	}

	if(option === 'last_n_days') {
		n_days.show();
	} else {
		n_days.hide();
	}
}

$.fn.serializeObject = function()
{
	var o = {};
	var a = this.serializeArray();
	$.each(a, function() {
		var name = this.name;
		name = name.replace('[]','');

		if (o[name]) {
			if (!o[name].push) {
				o[name] = [o[name]];
			}
			o[name].push(this.value || '');
		} else {
			o[name] = this.value || '';
		}
	});
	return o;
};

function backupRecordings(e) {
	var form = e.parents('form');
	var data = form.serializeObject();
	var searchForm = $("#search_calls_form");

	data['search_arguments'] = searchForm.serializeObject();
	console.log(data);

	$.ajax({
		type: "POST",
		url: CallBack,
		dataType: 'json',
		data: data,
		beforeSend: function () {
			showLoader();
		},
		success: function (Response) {
			processServerResponse(Response);
		},
		error: processServerErrors
	});
}